﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WinFormsApp1
{
    internal class MapsCollection
    {
        readonly Dictionary<string, MapWithSetTraktorGeneric<DrawningObjectTractor, AbstractMap>> _mapStorages;

        public List<string> Keys => _mapStorages.Keys.ToList();

        private readonly int _pictureWidth;

        private readonly int _pictureHeight;

        public MapsCollection(int pictureWidth, int pictureHeight)
        {
            _mapStorages = new Dictionary<string, MapWithSetTraktorGeneric<DrawningObjectTractor, AbstractMap>>();
            _pictureWidth = pictureWidth;
            _pictureHeight = pictureHeight;
        }

        public void AddMap(string name, AbstractMap map)
        {
            if (_mapStorages.ContainsKey(name)) return; //уникальное имя
            else
            {
                _mapStorages.Add(name, new MapWithSetTraktorGeneric<DrawningObjectTractor, AbstractMap>(_pictureWidth, _pictureHeight, map));
            }
        }

        public void DelMap(string name)
        {
            if (_mapStorages.ContainsKey(name))
            {
                _mapStorages.Remove(name);
            }
        }

        public MapWithSetTraktorGeneric<DrawningObjectTractor, AbstractMap> this[string ind]
        {
            get
            {
                _mapStorages.TryGetValue(ind, out var MapWithSetDoubleDeckerBusGeneric);
                return MapWithSetDoubleDeckerBusGeneric;
            }

        }
    }
}
